function [logpost] = getregpost(yvar,xvar,data)
    n = size(data,1);
    delta = 2;
    tau = 1;
    
    logpost = 0;
    Y = data(:,yvar);
    X = data(:,xvar);
    npred = length(xvar);
    if(length(xvar)==0)
        logpost = gammaln((n+delta)/2)-log(tau)/2-(n+delta)*log(tau+sum(Y.*Y))/2-gammaln(delta/2)-n*log(pi)/2+delta*log(tau)/2;
    else
        M = tau*eye(npred)+X'*X;
        logM = sum(log(eig(M)));
        q = sum(Y.*Y)-Y'*X*inv(M)*X'*Y;
        nu = tau+q;
        logpost = -n*log(pi)/2+(delta+2*npred)*log(tau)/2-logM/2+gammaln((n+delta+npred)/2)-gammaln((delta+npred)/2)-(n+delta+npred)*log(nu)/2;
    end;
    return;