function [idata,idesc] = interactdata(data,response,regs,nregs)
    n = size(data,1);
    p = size(data,2)-1; %number of main effects
    allvars = [response];
    for(i=1:nregs)
        allvars = [allvars regs{i}];
    end;
    allvars = sort(unique(allvars));
    
    nivars = max(allvars);
    idata = sparse(n,nivars);
    
    idesc = cell(1);
    
    for(k=1:length(allvars))
        v = allvars(k);
        if(v<=p+1)
            idata(:,v) = data(:,v);
            idesc{k} = sprintf('%d:%d',v,v);
        else
            ind = v-(p+1);
            for(i=1:p)
                j = ind-(i-1)*(p-i/2);
                if((i<=j)&(j<=p))
                    break;
                end;
            end;
            idesc{k} = sprintf('%d:%d:%d',v,i,j);
            x = data(:,i).*data(:,j);
            idata(:,v) = (x-mean(x))/std(x);
        end;
    end;