function [] = interactregprobs(DataFileName,ResponseVariable,nMaxRegressors,rcL,rcE,rcU)
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregs = length(regs);
    
    %get the indices of all the variables
    data = load(DataFileName);
    [idata,idesc] = interactdata(data,ResponseVariable,regs,nregs);
    
    regweight = zeros(1,nregs);
    for(i=1:nregs)
        regweight(i) = getregpost(ResponseVariable,regs{i},idata);
    end;
    a=exp(regweight-max(regweight));
    regweight = a/sum(a);
    
    iprob = zeros(1,size(idata,2));
    for(i=1:nregs)
        for(j=1:length(regs{i}))
           v = regs{i}(j);
           iprob(v) = iprob(v)+regweight(i);
        end;
    end;
    
    allvars = [ResponseVariable];
    for(i=1:nregs)
        allvars = [allvars regs{i}];
    end;
    allvars = sort(unique(allvars));
    iprob = iprob(allvars);
    rcL = rcL(allvars);
    rcE = rcE(allvars);
    rcU = rcU(allvars);
    
    [b,index] = sort(-iprob);
    idesc = idesc(index);
    iprob=iprob(index);
    rcL = rcL(index);
    rcE = rcE(index);
    rcU = rcU(index);
    
    fid = fopen(sprintf('%s.%d.%d.wgt',DataFileName,ResponseVariable,nMaxRegressors),'w');
    for(i=1:length(iprob))
        fprintf(fid,'%s\t%.5f\t%.5f\t%.5f\t%.5f\n',idesc{i},iprob(i),rcL(i),rcE(i),rcU(i));
    end;
    fclose(fid);