DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/diabetesfirstorder.txt';
FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/RegFitted/diabetesfirstorder.txt';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/RegCvv/diabetesfirstorder.txt';
ResponseVariable = 11;
nMaxRegressors = 65;

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/simulated/athousand/sim100x1000.txt';
FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/simulated/athousand/Fitted/sim100x1000.txt';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/simulated/athousand/Cvv/sim100x1000.txt';
ResponseVariable = 1;

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/jcgs/jcgs.89x12558.rma.dat';
FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/jcgs/Fitted/jcgs.89x12558.rma.dat';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/jcgs/Cvv/jcgs.89x12558.rma.dat';
ResponseVariable = 10959;
nMaxRegressors = 12557;

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/mathmarks/mathmarksnorm.txt';
FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/mathmarks/FittedReg/mathmarksnorm.txt';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/mathmarks/CvvReg/mathmarksnorm.txt';
ResponseVariable = 3;
nMaxRegressors = 4;

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/10/Model4/model4.txt';
FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/10/Model4/RegFitted/model4.txt';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/10/Model4/RegCvv/model4.txt';
ResponseVariable = 1;
nMaxRegressors = 9;

nChainIterations = 10000; %number of simulations for each sample
nCvvFold = 5;

%load the regression models
regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
nregs = length(regs)

rand('state',sum(100*clock));
fprintf('processing [%d] [%d]\n',ResponseVariable,nregs);

FittedReg(ResponseVariable,nMaxRegressors,DataFileName,FittedFileName,nChainIterations,regs,nregs);
CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregs);

%plot this information
fitinfo = load(sprintf('%s.%d.%d.fiterr',FittedFileName,ResponseVariable,nregs)); 
cvvinfo = load(sprintf('%s.%d.%d.cvverr',CvvFileName,ResponseVariable,nregs)); 

subplot(2,2,1);
hold on;
set(gca,'ygrid','on');
shift = 0.2;
for(i=1:nregs)
    plot(i,fitinfo(i,1),'bo',i+shift,cvvinfo(i,1),'rx');
end;
legend('Fitted','Cross-validation');

for(i=1:(nregs-1))
    plot([i i+1],[fitinfo(i,1) fitinfo(i+1,1)],'b-');
end;
for(i=1:nregs)
    plot([i i],[fitinfo(i,2) fitinfo(i,4)],'b-');
end;

for(i=1:(nregs-1))
    plot([i+shift i+1+shift],[cvvinfo(i,1) cvvinfo(i+1,1)],'r-');
end;
for(i=1:nregs)
    plot([i+shift i+shift],[cvvinfo(i,2) cvvinfo(i,4)],'r-');
end;
xlim([0 nregs+1]);
xlabel('Number of Regressions');
ylabel('Proportion Explained');
set(gca,'xtick',0:2:(nregs+1));
hold off;

subplot(2,2,2);
nvars = zeros(nregs,1);
a = [];
for(i=1:nregs)
   a = [a regs{i}];
   nvars(i,1) = length(unique(a));
end;
bar(1:nregs,nvars);
xlim([1 nregs+1]);
ylim([0 max(nvars)+1]);
set(gca,'xtick',1:2:nregs);
set(gca,'ytick',0:2:(max(nvars)+1));
xlabel('Number of Regressions');
ylabel('Number of Regressors Involved');

subplot(2,2,3);
b = 1:nregs;
j = b(min(find(cvvinfo(:,1)==max(cvvinfo(:,1)))));
a = load(sprintf('%s.%d.%d.fitted',FittedFileName,ResponseVariable,j));
hold on;
for(i=1:size(a,1))
    plot(a(i,1),a(i,2),'b.');
end;
for(i=1:size(a,1))
    plot([a(i,1) a(i,1)],[a(i,3) a(i,5)],'b-');
end;
amin = min(min(a(:,1)),min(a(:,2)))-0.1;
amax = max(max(a(:,1)),max(a(:,2)))+0.1;
xlim([amin amax]);
ylim([amin amax]);
xlabel('Observed Values');
ylabel('Fitted');
title(sprintf('Number of Regressions = %d',j));
plot([-2 2],[-2 2],'r-');
hold off;
grid on;

subplot(2,2,4);
a = load(sprintf('%s.%d.%d.cvv',CvvFileName,ResponseVariable,j));
hold on;
for(i=1:size(a,1))
    plot(a(i,1),a(i,2),'b.');
end;
for(i=1:size(a,1))
    plot([a(i,1) a(i,1)],[a(i,3) a(i,5)],'b-');
end;
amin = min(min(a(:,1)),min(a(:,2)))-0.1;
amax = max(max(a(:,1)),max(a(:,2)))+0.1;
xlim([amin amax]);
ylim([amin amax]);
xlabel('Observed Values');
ylabel('Cross-validation');
title(sprintf('Number of Regressions = %d',j));
plot([-2 2],[-2 2],'r-');
hold off;
grid on;