function [E,G] = makegraph(DataFileName)
    data = load(DataFileName);
    PredictorsFileName = sprintf('%s.predictors',DataFileName);
    [v1,v2,w] = textread(PredictorsFileName,'%d %d %f');
    
    nvars = size(data,2);
    E = sparse(nvars,nvars);
    for(i=1:length(v1))
        if(0==E(v1(i),v2(i)))
            E(v1(i),v2(i)) = w(i);
            E(v2(i),v1(i)) = w(i);
        else
            a = (w(i)+E(v1(i),v2(i)))/2;
            E(v1(i),v2(i)) = a;
            E(v2(i),v1(i)) = a;
        end;
    end;
    
    [v1,v2,w] = find(E);
    index = find(w>0.5);
    v1 = v1(index);
    v2 = v2(index);
    w = w(index);
   
    G = sparse(v1,v2,w,nvars,nvars);
    
    [v1,v2,w] = find(E);
    EdgesFileName = sprintf('%s.edges',DataFileName);
    fout = fopen(EdgesFileName,'w');
    for(i=1:length(v1))
        if(v1(i)<v2(i))
            fprintf(fout,'%d\t%d\t%.5f\n',v1(i),v2(i),w(i));
        end;
    end;
    fclose(fout);
    
    [v1,v2,w] = find(G);
    EdgesFileName = sprintf('%s.graph',DataFileName);
    fout = fopen(EdgesFileName,'w');
    for(i=1:length(v1))
        if(v1(i)<v2(i))
            fprintf(fout,'%d\t%d\n',v1(i),v2(i));
        end;
    end;
    fclose(fout);