nsim = 100;
n = 50;
minprob = 0.95;
DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegSelWorkDir/data.txt';


for(p = 13:50)
    ResponseVariable = p+1;
    VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,n-1);
    
    truevars = zeros(1,p);
    truevars(1:4)  = 1;

    adrian = fopen(sprintf('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegSelResults/pred%d.txt',p),'w');
    for(asim = 1:nsim)
        %generate the data
        data = zeros(n,p+1);
        for(i = 1:p)
            data(:,i) = normrnd(zeros(n,1),ones(n,1));
        end;
        for(i = 1:n)
            data(i,p+1) = normrnd(1.3*data(i,1)+0.3*data(i,2)-1.2*data(i,3)-0.5*data(i,4),0.5);
        end;
    
        %center and scale the data
        X = data;
        for(i=1:size(X,2))
            amean = mean(X(:,i));
            astd = std(X(:,i));
            X(:,i) = (X(:,i)-amean)/astd;
        end;
    
        fid = fopen(DataFileName,'w');
        for(i=1:size(X,1))
            fprintf(fid,'%.5f',X(i,1));
            for(j=2:size(X,2))
                fprintf(fid,'\t%.5f',X(i,j));
            end;
            fprintf(fid,'\n');
        end;
        fclose(fid);
    
        %do the simple regression model search
        system(sprintf('/Users/adobra/Projects/LargeRegression/Continuous/VariableSelection/SimpleRegression/varsel %d',p+1));
        regs = loadregs(DataFileName,ResponseVariable,n-1);
        nregs = length(regs);
    
        vars = load(VarFileName);
        myvars = zeros(1,p);
        myvars(vars(find(vars(:,3)>=minprob),2)) = 1;
    
        sprFileName = sprintf('%s.%d.%d.spr',DataFileName,ResponseVariable,n-1);
        spaceratio = load(sprFileName);
        
        a = truevars-myvars;
        fprintf(adrian,'%d\t%d\t%d\t%.5f\n',length(a(find(a==1))),length(a(find(a==-1))),nregs,spaceratio);
    end;
    fclose(adrian);
end;