nsim = 100;
n = 50;
minprob = 0.95;
DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegSelInteractWorkDir/data.txt';


for(p = 500)
    ResponseVariable = p+1;
    VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,n-1);
    RegFileName = sprintf('%s.%d.%d.reg',DataFileName,ResponseVariable,n-1);
   
    adrian = fopen(sprintf('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegSelInteractResults/pred%d.txt',p),'w');
    for(asim = 1:nsim)
        %generate the data
        data = zeros(n,p+1);
        for(i = 1:p)
            data(:,i) = normrnd(zeros(n,1),ones(n,1));
        end;
        for(i = 1:n)
            data(i,p+1) = normrnd(1.3*data(i,1)+0.3*data(i,2)-1.2*data(i,3)-0.5*data(i,4)-1.4*data(i,1)*data(i,2)+0.9*data(i,3)*data(i,3)+1.25*data(i,4)*data(i,4),0.5);
        end;
    
        %center and scale the data
        X = data;
        for(i=1:size(X,2))
            amean = mean(X(:,i));
            astd = std(X(:,i));
            X(:,i) = (X(:,i)-amean)/astd;
        end;
    
        fid = fopen(DataFileName,'w');
        for(i=1:size(X,1))
            fprintf(fid,'%.5f',X(i,1));
            for(j=2:size(X,2))
                fprintf(fid,'\t%.5f',X(i,j));
            end;
            fprintf(fid,'\n');
        end;
        fclose(fid);
    
        %do the simple regression model search
        !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/regsel

        regs = loadregs(DataFileName,ResponseVariable,n-1);
        nregs = length(regs);
    
        maxindex = 0;
        for(i=1:nregs)
            maxindex = max(maxindex,max(regs{i}));
        end;
        
        truevars = sparse(1,maxindex);
        truevars(1:4) = 1;
        truevars(MakeInteractionIndex(p,1,2)) = 1;
        truevars(MakeInteractionIndex(p,3,3)) = 1;
        truevars(MakeInteractionIndex(p,4,4)) = 1;
           
        vars = load(RegFileName);
        vars = vars(:,2);
        probs = sparse(1,maxindex);
        for(i=1:nregs)
            probs(regs{i}) = probs(regs{i})+vars(i);
        end;
        
        
        myvars = sparse(1,maxindex);
        myvars(find(probs>=minprob)) = 1;
    
        a = truevars-myvars;
        fprintf(adrian,'%d\t%d\t%d\n',length(a(find(a==1))),length(a(find(a==-1))),nregs);
    end;
    fclose(adrian);
end;