function [G,Gnew] = simreg(ResponseVariable,nMaxRegressors,DataFileName,nChainIterations,G,Gnew)
    %some parameters needed for simulation
    tau = 1;
    delta = 2;
    
    %load the dataset
    data = load(DataFileName);
    nSampleSize = size(data,1); 
    
    mysamples = zeros(nSampleSize,nChainIterations);            
    mydata = data;
        
    %sample size
    n = size(mydata,1);
    
    pred = find(G(ResponseVariable,:));
    npred = length(pred);

    if(npred>=1)
        allregcoef = zeros(nChainIterations,size(data,2));
        Y = mydata(:,ResponseVariable);
        for(iteration=1:nChainIterations)
            X = mydata(:,pred);
            M = tau*eye(npred)+X'*X;
            R = M\(X'*Y);
            nu = tau+Y'*Y-Y'*X*R;
            psi = 1/gamrnd((delta+npred+n)/2,2/nu);
            Minv=M\eye(npred);
            regcoef = mvnrnd(R',psi*Minv);
            for(i=1:nSampleSize)
                mysamples(i,iteration) = sum(data(i,pred).*regcoef);
            end;
            allregcoef(iteration,pred) = regcoef;
        end;
        
        selvar = [];
        for(i=1:size(allregcoef,2))
            if(i~=ResponseVariable)
                a = prctile(allregcoef(:,i),[2.5 97.5]);
                if((0.0001<=a(1))|(a(2)<=-0.0001))
                    selvar = [selvar i];
                end;
            end;
        end;

        for(i=1:length(selvar))
            Gnew(ResponseVariable,selvar(i)) = Gnew(ResponseVariable,selvar(i))+1;
            Gnew(selvar(i),ResponseVariable) = Gnew(selvar(i),ResponseVariable)+1;
        end;
    end;