nsim = 100;
n = 50;
p = 10;

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/data.txt';
OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/data.txt.omega';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/RegCvv/data.txt';
ResponseVariable = p;
nChainIterations = 1000; %number of simulations for each sample
nCvvFold = 5;
nCvvReplicates = 10;

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model8.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    C(1,p) = 0.4;
    C(p,1) = 0.4;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model7.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(1,i) = 0.2;
        C(i,1) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model6.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        for(j=1:p)
            C(i,j) = 0.5;
            C(j,i) = 0.5;
        end;
    end;
    for(i=1:p)
        C(i,i) = 1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model5.txt','w');
for(asim = 1:60)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;

    for(i=5:p)
        C(i,i-4) = 0.1;
        C(i-4,i) = 0.1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv); 
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model4.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred4
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred4
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred4.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred4.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred4.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred4.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir4/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model3.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    for(i=3:p)
        C(i,i-2) = 0.25;
        C(i-2,i) = 0.25;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred3
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred3
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred3.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred3.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred3.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred3.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir3/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model2.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred2
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred2
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred2.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred2.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred2.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred2.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir2/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/model1.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred1
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred1
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred1.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred1.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred1.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/simpred1.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/data.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/data.txt.sample
    
    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1)
    
    dagR2fit = FittedSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,dags);
    
    dagR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        dagR2cvv = [dagR2cvv CvvSigma(ResponseVariable,DataFileName,CvvFileName,nChainIterations,nCvvFold,dags)];
    end;
    dagR2cvv = mean(dagR2cvv);  
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir1/*.trace
    
    fprintf(adrian,'%.5f\t %d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%d\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,interRegR2fit,interRegR2cvv,ndags,dagR2fit,dagR2cvv);
end;
fclose(adrian);