nsim = 100;
n = 50;
p = 10;

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt';
OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt.omega';
CvvFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/RegCvv/data.txt';
ResponseVariable = p;
nChainIterations = 1000; %number of simulations for each sample
nCvvFold = 5;
nCvvReplicates = 10;

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim8.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    C(1,p) = 0.4;
    C(p,1) = 0.4;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim7.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(1,i) = 0.2;
        C(i,1) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim6.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        for(j=1:p)
            C(i,j) = 0.5;
            C(j,i) = 0.5;
        end;
    end;
    for(i=1:p)
        C(i,i) = 1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim5.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;

    for(i=5:p)
        C(i,i-4) = 0.1;
        C(i-4,i) = 0.1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim4.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim3.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    for(i=3:p)
        C(i,i-2) = 0.25;
        C(i-2,i) = 0.25;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim2.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredResults/modelregsim1.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    trueR2 = (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1);

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    %move the response variable at the end
    X = X(:,[2:p 1]);
    
    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
   
    %do the simple regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/simpred
    
    %predict with these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredSimpleReg = mean(mypred);
    nregsSimpleReg = length(regs);
    simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
    simpleRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
    end;
    simpleRegR2cvv = mean(simpleRegR2cvv);
    
    %do the regression model search with interactions
    !/Users/adobra/Projects/LargeRegression/Continuous/RegInteraction/simpred
    
    %predict using these models
    nMaxRegressors = n-1;
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    mypred = [];
    for(i=1:length(regs))
        mypred = [mypred length(regs{i})];
    end;
    npredInterReg = mean(mypred);
    nregsInterReg = length(regs);
    interRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsInterReg);
    
    interRegR2cvv = [];
    for(areplicate=1:nCvvReplicates)
        interRegR2cvv  = [interRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsInterReg)];
    end;
    interRegR2cvv = mean(interRegR2cvv);
    
    fprintf(adrian,'%.5f\t%d\t%.5f\t%.5f\t%.5f\t%d\t%.5f\t%.5f\t%.5f\n',trueR2,nregsSimpleReg,npredSimpleReg,simpleRegR2fit,simpleRegR2cvv,nregsInterReg,npredInterReg,interRegR2fit,interRegR2cvv);
end;
fclose(adrian);