nsim = 100;
adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model8.txt','w');

for(asim = 1:nsim)
    %CYCLE
    n = 50;
    p = 10;

    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    C(1,p) = 0.4;
    C(p,1) = 0.4;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    G = sparse(p,p);

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt.omega';
    FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/Fitted/stepbystep.txt';
    nChainIterations = 1000; %number of simulations for each sample
    nMaxRegressors = 9;

    for(ResponseVariable = 1:p)
        %load the regression models
        regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
        nregs = length(regs);

        rand('state',sum(100*clock));
        fprintf('processing [%d] [%d]\n',ResponseVariable,nregs);
    
        G = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,FittedFileName,nChainIterations,regs,nregs,G);
    end;

    [i,j,s]=find(G);
    k = find(s==2);
    G=sparse(i(k),j(k),ones(1,length(k)),p,p);

    GraphFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt.predictors'; 
    fout = fopen(GraphFileName,'w');
    [i,j,s] = find(G);
    for(k=1:length(i))
        if(i(k)<j(k))
            fprintf(fout,'%d\t%d\n',i(k),j(k));
        end;
    end;
    fclose(fout);

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);