G = sparse(p,p);

DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt';
OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt.omega';
FittedFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/Fitted/stepbystep.txt';
nChainIterations = 1000; %number of simulations for each sample
nMaxRegressors = 9;

for(ResponseVariable = 1:p)
    %load the regression models
    regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
    nregs = length(regs);

    rand('state',sum(100*clock));
    fprintf('processing [%d] [%d]\n',ResponseVariable,nregs);
    
    G = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,FittedFileName,nChainIterations,regs,nregs,G);
end;

[i,j,s]=find(G);
k = find(s==2);
G=sparse(i(k),j(k),ones(1,length(k)),p,p);

GraphFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep/stepbystep.txt.predictors';
fout = fopen(GraphFileName,'w');
[i,j,s] = find(G);
for(k=1:length(i))
    if(i(k)<j(k))
        fprintf(fout,'%d\t%d\n',i(k),j(k));
    end;
end;
fclose(fout);

[i,j,s]=find(C);
trueG = sparse(i,j,ones(length(i),1));
trueG = trueG-diag(ones(p,1));

diffG = G-trueG;
[i,j,s]=find(diffG);

FP = length(s(find(s==1)));
FN = length(s(find(s==-1)));

fprintf('%d\t%d\n',FP,FN)
