n = 25;
p = 5;
DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/recreg/stepbystep.txt';
nChainIterations = 2500; %number of simulations for each sample
nsim = 100;

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model8.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    C(1,p) = 0.4;
    C(p,1) = 0.4;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model7.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(1,i) = 0.2;
        C(i,1) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model6.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        for(j=1:p)
            C(i,j) = 0.5;
            C(j,i) = 0.5;
        end;
    end;
    for(i=1:p)
        C(i,i) = 1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model5.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;

    for(i=5:p)
        C(i,i-4) = 0.1;
        C(i-4,i) = 0.1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model4.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model3.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    for(i=3:p)
        C(i,i-2) = 0.25;
        C(i-2,i) = 0.25;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model2.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/RegResults/model1.txt','w');
for(asim = 1:nsim)    
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen(DataFileName,'w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);

    %run the regression model search
    !/Users/adobra/Projects/LargeRegression/Continuous/Source/largeregcont
    
    %construct the initial graph from the .var files
    G = sparse(p,p);
    for(ResponseVariable = 1:p)
        VarFileName = sprintf('%s.%d.%d.var',DataFileName,ResponseVariable,p-1);
        mydata = load(VarFileName);
        for(i=1:size(mydata,1))
            G(mydata(i,1),mydata(i,2)) = 1;
            G(mydata(i,2),mydata(i,1)) = 1;
        end;
    end;

    while(1)
        Gnew = sparse(p,p);
        for(ResponseVariable = 1:p)
            [G,Gnew]=simreg(ResponseVariable,p-1,DataFileName,nChainIterations,G,Gnew);
        end;
        [i,j,s]=find(Gnew);
        myind = find(s==2);
        Gnew = sparse(i(myind),j(myind),ones(length(myind),1),p,p);
        if(0==nnz(Gnew-G))
           break;
        else
           G = Gnew;
        end;
    end;

    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));
    trueG = trueG-diag(ones(p,1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    fprintf(adrian,'%d\t%d\n',FP,FN);
end;
fclose(adrian);