nsim = 100;
n = 25;
p = 5;

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model8.txt','w');
for(asim = 1:0)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    C(1,p) = 0.4;
    C(p,1) = 0.4;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
    
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model7.txt','w');
for(asim = 1:1)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(1,i) = 0.2;
        C(i,1) = 0.2;
    end;

    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
    
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model6.txt','w');
for(asim = 1:3)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        for(j=1:p)
            C(i,j) = 0.5;
            C(j,i) = 0.5;
        end;
    end;
    for(i=1:p)
        C(i,i) = 1;
    end;
    

    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model5.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;

    for(i=5:p)
        C(i,i-4) = 0.1;
        C(i-4,i) = 0.1;
    end;

    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model4.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;

    for(i=2:p)
        C(i,i-1) = 0.4;
        C(i-1,i) = 0.4;
    end;

    for(i=3:p)
        C(i,i-2) = 0.2;
        C(i-2,i) = 0.2;
    end;

    for(i=4:p)
        C(i,i-3) = 0.2;
        C(i-3,i) = 0.2;
    end;
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model3.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;

    for(i=3:p)
        C(i,i-2) = 0.25;
        C(i-2,i) = 0.25;
    end;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
    
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model2.txt','w');
for(asim = 1:nsim)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
    
    for(i=2:p)
        C(i,i-1) = 0.5;
        C(i-1,i) = 0.5;
    end;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
    
end;
fclose(adrian);

adrian = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/DagResults5/model1.txt','w');
for(asim = 1:5)
    mu = zeros(p,1);
    C = zeros(p,p);
    for(i=1:p)
        C(i,i) = 1;
    end;
 
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    R = chol(C);
    Rinv = R\eye(size(C,1));
    Sigma = Rinv*Rinv';

    (Sigma(1,2:p)*inv(Sigma(2:p,2:p))*Sigma(2:p,1))/Sigma(1,1)

    data = zeros(n,p);
    for(i=1:n)
        b = normrnd(0,1,p,1);
        a = Rinv*b;
        data(i,:) = a';
    end;

    %Generate data
    X = data;
    for(i=1:size(X,2))
        amean = mean(X(:,i));
        astd = std(X(:,i));
        X(:,i) = (X(:,i)-amean)/astd;
    end;

    fid = fopen('/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt','w');
    for(i=1:size(X,1))
        fprintf(fid,'%.5f',X(i,1));
        for(j=2:size(X,2))
            fprintf(fid,'\t%.5f',X(i,j));
        end;
        fprintf(fid,'\n');
    end;
    fclose(fid);
    
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 1
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 2
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 3
    !/Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/fastdag /Users/adobra/Projects/LargeRegression/Continuous/serialhdbcs/ParameterFiles/mingyuan.parameters5.txt 4
    !cat /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.?.sample > /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.sample

    DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt';
    OmegaFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/stepbystep5dag.txt.omega';
    nChainIterations = 10000; %number of simulations for each sample
    [avecor,allcoef] = bmaomega(nChainIterations,DataFileName,OmegaFileName);
    
    %Kullback-Leibler loss
    KL = -sum(log((eig(full(avecor)))))+trace(avecor*Sigma)+sum(log((eig(C))))-p
    
    gcoef = zeros(1,size(allcoef,2));
    for(i=1:size(allcoef,2))
        a = prctile(allcoef(:,i),[2.5 97.5]);
        if((0.0001<=a(1))|(a(2)<=-0.0001))
            gcoef(i) = 1;
        end;
    end;
    G = reshape(gcoef,p,p);
    
    [i,j,s]=find(C);
    trueG = sparse(i,j,ones(length(i),1));

    diffG = G-trueG;
    [i,j,s]=find(diffG);

    FP = length(s(find(s==1)));
    FN = length(s(find(s==-1)));

    dags = significantdags(sprintf('%s.sample',DataFileName));
    ndags = size(dags,1);
    fprintf(adrian,'%.5f\t%d\t%d\t%d\n',KL,FP,FN,ndags);
    
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*sample
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.dag
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.1.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.2.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.3.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.4.alpha
    !rm /Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/stepbystep5/*.trace
    
end;
fclose(adrian);