/*
AUTHOR: ADRIAN DOBRA (ADOBRA@STAT.WASHINGTON.EDU)
*/
// dgraph.h: interface for the DGraph class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(DGRAPH_H)
#define DGRAPH_H
#include <set>
#include <vector>
using namespace std;
class DGraph  
{
public:
	DGraph(int nvertices);
	DGraph(const char* GraphFile, int nvertices);
	virtual ~DGraph();

	int mnvertices;
	set<int>* graph;

	void InitGraph(int nvertices);
	void DeleteGraph();
	void AddEdge(int vi,int vj);
	void DeleteEdge(int vi,int vj);
	void PrintGraph(FILE* out);
	void SaveGraph(char* filePath);
	void ReadGraph(const char* GraphFile);
	int IsEdge(int target,int v);
};
#endif
