DataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/diabetes11norm.txt'; %name of the data file
ResponseVariable = 11; %response variable

%names of the new data file
NewDataFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/diabetesfirstorder.txt';
NewDependencyFileName = '/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/diabetesfirstorder.dependency.txt';

%load the data
data = load(DataFileName);
sampleSize = size(data,1);
nvars = size(data,2);

%last index assigned to a variable
lastvar = nvars;

dependency = zeros(1,2);
for(i=1:nvars)
    dependency(i,1) = i;
    dependency(i,2) = -1;
end;

newdata = data;
nvars = nvars-1; %the last variable is the response
%x^2
for(i=1:nvars)
    lastvar = lastvar+1;
    newdata(:,lastvar) = data(:,i).*data(:,i);
    dependency(lastvar,1) = i;
    dependency(lastvar,2) = -1;
end;

%x*y
for(i=1:(nvars-1))
    for(j=(i+1):nvars)
        lastvar = lastvar+1;
        newdata(:,lastvar) = data(:,i).*data(:,j);
        dependency(lastvar,1) = i;
        dependency(lastvar,2) = j;
    end;
end;

%center and scale the new data
X = newdata;
for(i=1:size(X,2))
    amean = mean(X(:,i));
    astd = std(X(:,i));
    X(:,i) = (X(:,i)-amean)/astd;
end;

fid = fopen(NewDataFileName,'w');
for(i=1:size(X,1))
    fprintf(fid,'%.5f',X(i,1));
    for(j=2:size(X,2))
        fprintf(fid,'\t%.5f',X(i,j));
    end;
    fprintf(fid,'\n');
end;
fclose(fid);

fid = fopen(NewDependencyFileName,'w');
for(i=1:size(dependency,1))
    for(j=1:size(dependency,2))
        if(-1~=dependency(i,j))
            if(i~=dependency(i,j))
                fprintf(fid,'%d\t%d\n',i,dependency(i,j));
            end;
        end;
    end;
end;
fclose(fid);