/*
AUTHOR: ADRIAN DOBRA (ADOBRA@STAT.WASHINGTON.EDU)
*/

#if !defined(REGMODELS_H)
#define REGMODELS_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <set>
using namespace std;

#if !defined(REG_EPSILON)
#define REG_EPSILON 0.1
#endif

class CRegression
{
public:
	CRegression();
	virtual ~CRegression();
	
	double Weight;
	double normWeight;
	set<int> Vars;
	CRegression* Next;
	int nmodels;
	int nmaxmodels;
	
	void DeleteAll();
	void Delete();
	void DeleteNotRelevant(double maxweight);
	int AddReg(double weight,set<int> vars);
	double NormalizeWeights();
	void MakeCovProbs(int ncov,double* probs);
	void LoadAll(int nMaxRegressors,FILE* file);
	void SaveAll(int nMaxRegressors,FILE* file);
};
#endif