/*
 *  largeregcont.h
 *  
 *
 *  Created by Adrian Dobra on 11/22/06.
 *  Copyright 2006 __University of Washington__. All rights reserved.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string>
#include <iomanip>
#include <time.h>

using namespace std;

#include "mkl_vsl.h"

#define SEED    777777
#define BRNG    VSL_BRNG_MT19937
#define METHOD  0

#include "util.h"
#include "Data.h"
#include "gibbssampler.h"

/*
//Theo Eicher
char sDataFile[] = "/Users/adobra/Projects/Theo Eicher/Data/FLSgrowthnorm.txt";
int NumberOfVariables = 42;
int SampleSize = 72;
int ResponseVariableMin = NumberOfVariables;
int ResponseVariableMax = NumberOfVariables;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = SampleSize-1;
int nMaxRegressorsMax = SampleSize-1;
*/

/*
//Ming Yuan
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/MingYuan/PredWorkDir/data.txt";
int NumberOfVariables = 10;
int SampleSize = 50;
int ResponseVariableMin = NumberOfVariables;
int ResponseVariableMax = NumberOfVariables;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = SampleSize-1;
int nMaxRegressorsMax = SampleSize-1;
*/


//TNL data
char sDataFile[] = "/Users/adobra/Projects/Rats/HeartBlood/Regression/HFABP/Heart/hfabpRatHeart.txt";
int NumberOfVariables = 11173;
int SampleSize = 15;
int ResponseVariableMin = NumberOfVariables;
int ResponseVariableMax = NumberOfVariables;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = SampleSize-1;
int nMaxRegressorsMax = SampleSize-1;


/*
//HFABP data
char sDataFile[] = "/Users/adobra/Projects/Rats/Code/HFABP/redhfabp.txt";
int NumberOfVariables = 16;
int SampleSize = 15;
int ResponseVariableMin = NumberOfVariables;
int ResponseVariableMax = NumberOfVariables;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = SampleSize-1;
int nMaxRegressorsMax = SampleSize-1;
*/

/*
//DIABETES DATA
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/diabetes/diabetes11norm.txt";
int NumberOfVariables = 11;
int SampleSize = 442;
int ResponseVariableMin = 11;
int ResponseVariableMax = 11;
int nChainIterations = 500;
int nChainReplicates = 4;
int nMaxRegressorsMin = 10;
int nMaxRegressorsMax = 10;
*/

/*
//MATH MARKS DATA
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/mathmarks/mathmarksnorm.txt";
int NumberOfVariables = 5;
int SampleSize = 88;
int ResponseVariableMin = 1;
int ResponseVariableMax = 5;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = 4;
int nMaxRegressorsMax = 4;
*/

/*
//FRET'S HEADS DATA
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/fretsheads/fretheadsnorm.txt";
int NumberOfVariables = 4;
int SampleSize = 25;
int ResponseVariableMin = 1;
int ResponseVariableMax = 4;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = 3;
int nMaxRegressorsMax = 3;
*/

/*
//CORK BORINGS DATA
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/cork/corknorm.txt";
int NumberOfVariables = 4;
int SampleSize = 28;
int ResponseVariableMin = 1;
int ResponseVariableMax = 4;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = 3;
int nMaxRegressorsMax = 3;
*/

/*
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/simulated/athousand/sim100x1000.txt";
int NumberOfVariables = 1000;
int SampleSize = 100;
int ResponseVariableMin = 1;
int ResponseVariableMax = 1000;
int nChainIterations = 25;
int nChainReplicates = 3;
int nMaxRegressorsMin = 5;
int nMaxRegressorsMax = 5;
*/

/*
char sDataFile[] = "/Users/adobra/Projects/LargeRegression/Continuous/Datasets/jcgs/jcgs.89x12558.rma.dat";
int NumberOfVariables = 12558;
int SampleSize = 89;
int ResponseVariableMin = 10769; //Estrogen receptor 10959 and 10769
int ResponseVariableMax = 10769 ;
int nChainIterations = 25;
int nChainReplicates = 4;
int nMaxRegressorsMin = 12557;
int nMaxRegressorsMax = 12557;
*/

/**** GLOBAL VARIABLES ****/
VSLStreamStatePtr mystream;
CData Data;
CGibbsSampler GS;
double* probs = NULL;
/**** GLOBAL VARIABLES ****/


