datafile = load('/Users/adobra/Projects/Theo Eicher/CapitalFlowData/oli_growth_36t68.txt');

X = datafile;
for(i=1:size(X,2))
    amean = mean(X(:,i));
    astd = std(X(:,i));
    X(:,i) = (X(:,i)-amean)/astd;
end;

fid = fopen('/Users/adobra/Projects/Theo Eicher/CapitalFlowData/oli_growth_36t68norm.txt','w');
for(i=1:size(X,1))
    fprintf(fid,'%.5f',X(i,1));
    for(j=2:size(X,2))
        fprintf(fid,'\t%.5f',X(i,j));
    end;
    fprintf(fid,'\n');
end;
fclose(fid);

DataFileName = '/Users/adobra/Projects/Theo Eicher/CapitalFlowData/oli_growth_36t68norm.txt';
ResponseVariable = size(X,2);
nMaxRegressors = size(X,1)-1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%do prediction using the regressions with interactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CvvFileName = '/Users/adobra/Projects/Theo Eicher/CapitalFlowData/RegCvv/oli_growth_36t68norm.txt';
ResponseVariable = size(X,2);
nChainIterations = 10000; %number of simulations for each sample
nCvvFold = 5;
nCvvReplicates = 10;
nMaxRegressors = size(X,1)-1;
regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
nregsSimpleReg = length(regs);

[rcL,rcE,rcU] = FittedRegCoef(ResponseVariable,nMaxRegressors,DataFileName,nChainIterations,regs,nregsSimpleReg);
interactregprobs(DataFileName,ResponseVariable,nMaxRegressors,rcL,rcE,rcU);

simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
simpleRegR2cvv = [];
for(areplicate=1:nCvvReplicates)
    simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
end;

simpleRegR2cvv
simpleRegR2cvv =
    0.7721    0.7684    0.7253    0.7830    0.7522    0.7686    0.7732    0.7630    0.7751    0.7382
simpleRegR2fit
simpleRegR2fit =
    0.9765
