datafile = load('/Users/adobra/Projects/Theo Eicher/Data/FLSgrowth.txt');

X = datafile;
for(i=1:size(X,2))
    amean = mean(X(:,i));
    astd = std(X(:,i));
    X(:,i) = (X(:,i)-amean)/astd;
end;

fid = fopen('/Users/adobra/Projects/Theo Eicher/Data/FLSgrowthnorm.txt','w');
for(i=1:size(X,1))
    fprintf(fid,'%.5f',X(i,1));
    for(j=2:size(X,2))
        fprintf(fid,'\t%.5f',X(i,j));
    end;
    fprintf(fid,'\n');
end;
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%do prediction using the regression models selected
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DataFileName = '/Users/adobra/Projects/Theo Eicher/Data/FLSgrowthnorm.txt';
CvvFileName = '/Users/adobra/Projects/Theo Eicher/Data/RegCvv/FLSgrowthnorm.txt';
ResponseVariable = size(X,2);
nChainIterations = 10000; %number of simulations for each sample
nCvvFold = 5;
nCvvReplicates = 100;

nMaxRegressors = size(X,1)-1;
regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
nregsSimpleReg = length(regs);
simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
    
simpleRegR2cvv = [];
for(areplicate=1:nCvvReplicates)
    simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
end;
%simpleRegR2cvv = mean(simpleRegR2cvv);

%FITTED RESULTS: 0.9050

%CVV results
%mean = 0.7074 std = 0.0248
%0.7302    0.7176    0.7175    0.6971    0.6692    0.7256    0.7374 0.7123    0.6630    0.7042

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%do prediction using the regressions with interactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DataFileName = '/Users/adobra/Projects/Theo Eicher/Interactions/FLSgrowthnorm.txt';
CvvFileName = '/Users/adobra/Projects/Theo Eicher/Interactions/RegCvv/FLSgrowthnorm.txt';
ResponseVariable = size(X,2);
nChainIterations = 10000; %number of simulations for each sample
nCvvFold = 5;
nCvvReplicates = 10;
nMaxRegressors = size(X,1)-1;
regs = loadregs(DataFileName,ResponseVariable,nMaxRegressors);
nregsSimpleReg = length(regs);

[rcL,rcE,rcU] = FittedRegCoef(ResponseVariable,nMaxRegressors,DataFileName,nChainIterations,regs,nregsSimpleReg);
interactregprobs(DataFileName,ResponseVariable,nMaxRegressors,rcL,rcE,rcU);

simpleRegR2fit  = FittedReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,regs,nregsSimpleReg);
simpleRegR2cvv = [];
for(areplicate=1:nCvvReplicates)
    simpleRegR2cvv  = [simpleRegR2cvv CvvReg(ResponseVariable,nMaxRegressors,DataFileName,CvvFileName,nChainIterations,nCvvFold,regs,nregsSimpleReg)];
end;


%REGRESSION WITH INTERACTIONS
%FITTED RESULTS: 0.9814

%CVV RESULTS
%MEAN: 0.8564   std = 0.0135
%0.8668    0.8426    0.8513    0.8492    0.8698    0.8826    0.8600     0.8571    0.8409    0.8441
